using System;

namespace _01Niz
{
    class Program
    {
        static void Main(string[] args)
        {
            int brojJedinica = 0;
            int brojNuli = 0;
            string[] ulaz = Console.ReadLine().Split();
            int n = int.Parse(ulaz[0]);
            int c = int.Parse(ulaz[1]);
            int q = int.Parse(ulaz[2]);
            string broj = Console.ReadLine();
            long[] rastavljenBroj = new long[n];
            long[] rezultat = new long[q];
            for (int i = 0; i < n; i++)
            {
                rastavljenBroj[i] = long.Parse(broj.Substring(i, 1));

            }
            for (int i = 0; i < q; i++)
            {
                ulaz = Console.ReadLine().Split();
                int l = int.Parse(ulaz[0]);
                int r = int.Parse(ulaz[1]);
                for (int y = l; y <= r; y++)
                {
                    if (rastavljenBroj[y - 1] == 0)
                    {
                        rastavljenBroj[y - 1] = 1;
                    }
                    else
                    {
                        rastavljenBroj[y - 1] = 0;
                    }
                }
                int oduzimanje = 0;
                for (int y = 0; y < n; y++)
                {
                    if (rastavljenBroj[y] == 0)
                    {
                        oduzimanje += 1;
                    }
                    else
                    {
                        y = n;
                    }
                }
                for (int y = n; y >= 0; y--)
                {
                    if (rastavljenBroj[y - 1] == 0)
                    {
                        oduzimanje += 1;
                    }
                    else if (rastavljenBroj[y - 1] == 1)
                    {
                        y = 0;
                    }
                }
                brojJedinica = 0;
                brojNuli = 0;
                for (int y = 0; y < n; y++)
                {

                    if (rastavljenBroj[y] == 1)
                    {
                        brojJedinica++;
                    }
                    else
                    {
                        brojNuli++;
                    }
                }

                if (brojJedinica > brojNuli)
                {
                    rezultat[i] = brojNuli - oduzimanje + c;
                }
                else
                {
                    rezultat[i] = brojJedinica;
                }
            }
            foreach (var item in rezultat)
            {
                Console.WriteLine(item);
            }
        }
    }
}